zoukankan      html  css  js  c++  java
  • Codeforces Round #201 (Div. 2)C,E

    数论:
    C. Alice and Bob
    time limit per test
    2 seconds
    memory limit per test
    256 megabytes
    input
    standard input
    output
    standard output

    It is so boring in the summer holiday, isn't it? So Alice and Bob have invented a new game to play. The rules are as follows. First, they get a set of n distinct integers. And then they take turns to make the following moves. During each move, either Alice or Bob (the player whose turn is the current) can choose two distinct integers x and y from the set, such that the set doesn't contain their absolute difference |x - y|. Then this player adds integer |x - y| to the set (so, the size of the set increases by one).

    If the current player has no valid move, he (or she) loses the game. The question is who will finally win the game if both players play optimally. Remember that Alice always moves first.

    Input

    The first line contains an integer n (2 ≤ n ≤ 100) — the initial number of elements in the set. The second line contains n distinct space-separated integers a1, a2, ..., an (1 ≤ ai ≤ 109) — the elements of the set.

    Output

    Print a single line with the winner's name. If Alice wins print "Alice", otherwise print "Bob" (without quotes).

    Examples
    input
    2
    2 3
    output
    Alice
    input
    2
    5 3
    output
    Alice
    input
    3
    5 6 7
    output
    Bob
    Note

    Consider the first test sample. Alice moves first, and the only move she can do is to choose 2 and 3, then to add 1 to the set. Next Bob moves, there is no valid move anymore, so the winner is Alice.

     题意:

    两人游戏,最初给出n个数集合当轮到一个人时他要从中选两个数x,y,使得|x-y|不在集合中,然后把|x-y|加进集合。当没法挑选时输。Alice先Bob后。

    代码:

    //并非1~n的每一个数都能得到。得到的数只可能是最初的n个数的最大公约束数的倍数。
    //因为不断地作减法可以看成求gcd的运算,最终减到的最小的数就是他们的gcd.
    #include<bits/stdc++.h>
    using namespace std;
    int n,a[100005],c[100005];
    int main()
    {
        cin>>n;
        int cnt=0,flag=0;
        for(int i=0;i<n;i++) cin>>a[i];
        for(int i=0;i<n;i++){
            if(a[i]==i) cnt++;
            else if(a[a[i]]==i) flag=1;
        }
        if(cnt==n) cout<<cnt<<endl;
        else if(flag) cout<<cnt+2<<endl;
        else cout<<cnt+1<<endl;
        return 0;
    }
    贪心 dp
    E. Number Transformation II
    time limit per test
    1 second
    memory limit per test
    256 megabytes
    input
    standard input
    output
    standard output

    You are given a sequence of positive integers x1, x2, ..., xn and two non-negative integers a and b. Your task is to transform a into b. To do that, you can perform the following moves:

    • subtract 1 from the current a;
    • subtract a mod xi (1 ≤ i ≤ n) from the current a.

    Operation a mod xi means taking the remainder after division of number a by number xi.

    Now you want to know the minimum number of moves needed to transform a into b.

    Input

    The first line contains a single integer n (1 ≤  n ≤ 105). The second line contains n space-separated integers x1, x2, ..., xn (2 ≤  xi ≤ 109). The third line contains two integers a and b (0  ≤ b ≤  a ≤ 109, a - b ≤ 106).

    Output

    Print a single integer — the required minimum number of moves needed to transform number a into number b.

    Examples
    input
    3
    3 4 5
    30 17
    output
    6
    input
    3
    5 6 7
    1000 200
    output
    206

     题意:

    给出n个数x[1...n]和a,b问从a变到b的最少步数。a每次可以减1或者减a%x[i]。

    代码:

    //每次减去1和a%x[i](0<=i<=n-1)中大的那个,直到a<=b。
    //剪枝:x数组去重;显然如果a-a%x[i]<b,x[i]就可以去掉,下次不用计算他了
    #include<bits/stdc++.h>
    using namespace std;
    int n,num[100005],a,b;
    int main()
    {
        cin>>n;
        for(int i=0;i<n;i++) cin>>num[i];
        cin>>a>>b;
        sort(num,num+n);
        int len=unique(num,num+n)-num;
        int ans=0,tmp;
        while(a>b){
            tmp=a-1;
            for(int i=0;i<len;i++){
                int tmpp=a-a%num[i];
                if(tmpp<b) num[i--]=num[--len];
                else tmp=min(tmp,tmpp);
            }
            a=tmp;
            ans++;
        }
        cout<<ans<<endl;
        return 0;
    }
  • 相关阅读:
    css基础面试题
    hack-checkbox
    装饰性属性
    【CF809E】Surprise me!
    [SCOI2012]奇怪的游戏
    [HAOI2018]奇怪的背包
    CF1139D Steps to One
    [CTSC2018]假面
    写在省选前
    [SDOI2015]寻宝游戏
  • 原文地址:https://www.cnblogs.com/--ZHIYUAN/p/6561790.html
Copyright © 2011-2022 走看看